﻿namespace Cop.Borovkov.Var3.Models
{
    /// <summary>
    /// Параметры для создания таблиц в пдф
    /// </summary>
    public record PdfTableInfo
    {
        /// <summary>
        /// имя файла (включая путь до файла)
        /// </summary>
        public string FilePath { get; init; } = @"C:\pdfTable.pdf";

        /// <summary>
        /// название документа(заголовок в документе)
        /// </summary>
        public string Title { get; init; } = "Таблица";

        /// <summary>
        /// Список таблиц
        /// </summary>
        public IEnumerable<string[,]> Tables { get; init; } = [];
    }
}
