﻿using System.Drawing;

namespace PIHelperSh.PdfCreator.Models.PieChartModel
{
    /// <summary>
    /// Элемент данных. Одно значение для диаграммы.
    /// </summary>
    public class PdfHistogramData
    {
        /// <summary>
        /// Название варианта
        /// </summary>
        public string DisplayName { get; set; } = null!;

        /// <summary>
        /// Значение варианта(по ним строят диаграмму)
        /// </summary>
        public IEnumerable<(string Name, double Value)> Value { get; set; }

        /// <summary>
        /// Цвет области на диаграмме. При null будет использоваться выдача цветов по умолчанию)
        /// </summary>
        public Color? Color { get; set; } = null;

        /// <summary>
        /// </summary>
        public PdfHistogramData() 
        { 
            Value = [];
        }

        /// <summary>
        /// </summary>
        /// <param name="displayName"></param>
        /// <param name="value"></param>
        public PdfHistogramData(string displayName, IEnumerable<(string, double)> value)
        {
            DisplayName = displayName;
            Value = value;
        }
    }
}
