﻿using Lab4.Forms;
using Lab4.Implementations;
using Lab4.Interfaces;
using Microsoft.Extensions.DependencyInjection;

namespace Lab4.Extensions
{
    public static class DiExtensions
    {
        public static IServiceCollection AddLab4Forms(
            this IServiceCollection services)
        {
            services.AddScoped<FormMain>();

            return services;
        }

        public static IServiceCollection AddScopes(
            this IServiceCollection services)
        {
            services.AddScoped<PluginsConvention>();

            services.AddScoped<Func<Type, IPluginsConvention>>(sp 
                => (type) => (sp.GetRequiredService(type) as IPluginsConvention)!);

            return services;
        }
    }
}
