using Lab3.Extensions;
using Lab3.Forms;
using Lab4.Extensions;
using Lab4.Forms;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;

namespace Lab4
{
    internal static class Program
    {
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            // To customize application configuration such as set high DPI settings or default font,
            // see https://aka.ms/applicationconfiguration.
            ApplicationConfiguration.Initialize();

            var app = CreateHostBuilder().Build();

            Application.Run(app.Services.GetRequiredService<FormMain>());
        }

        static IHostBuilder CreateHostBuilder()
        {
            return Host.CreateDefaultBuilder()
                .ConfigureAppConfiguration(c
                    => c.AddJsonFile("appsettings.json", optional: true, reloadOnChange: true))
                .ConfigureServices((context, services) => {

                    services.ConfigureDAL(context.Configuration);

                    services.AddMapping();

                    services.AddLab3Forms();
                    services.AddLab4Forms();

                    services.AddScopes();
                });
        }
    }
}